import { Injectable, ɵɵdefineInjectable, Component, Input, NgModule } from '@angular/core';
import { BehaviorSubject, Subject, race, timer, of } from 'rxjs';
import { map, debounce, take, tap, switchMap } from 'rxjs/operators';
import { BrowserModule } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-loading-spinner.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
var SpinnerActionType = {
    Show: 0, Hide: 1, None: 2,
};
SpinnerActionType[SpinnerActionType.Show] = 'Show';
SpinnerActionType[SpinnerActionType.Hide] = 'Hide';
SpinnerActionType[SpinnerActionType.None] = 'None';
;
var SpinnerAction = /** @class */ (function () {
    function SpinnerAction() {
    }
    return SpinnerAction;
}());
if (false) {
    /** @type {?} */
    SpinnerAction.prototype.type;
    /** @type {?} */
    SpinnerAction.prototype.immediate;
}
var NgxLoadingSpinnerService = /** @class */ (function () {
    function NgxLoadingSpinnerService() {
        this.visibleSubject = new BehaviorSubject(false);
        this.delayedSubject = new Subject();
        this.immediateSubject = new Subject();
        this.actionRequested = SpinnerActionType.None;
        this.actionExecuted = SpinnerActionType.None;
        this._timeout = 10000;
        this._threshold = 500;
        this.raceSubject();
    }
    Object.defineProperty(NgxLoadingSpinnerService.prototype, "timeout", {
        set: /**
         * @param {?} timeout
         * @return {?}
         */
        function (timeout) {
            this._timeout = timeout;
            this.patchShow();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxLoadingSpinnerService.prototype, "threshold", {
        set: /**
         * @param {?} threshold
         * @return {?}
         */
        function (threshold) {
            this._threshold = threshold;
            this.patchShow();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @return {?}
     */
    NgxLoadingSpinnerService.prototype.raceSubject = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var delayedSubject = this.delayedSubject.pipe(map((/**
         * @param {?} t
         * @return {?}
         */
        function (t) { return ((/** @type {?} */ ({ type: t, immediate: false }))); })));
        /** @type {?} */
        var immediateSubject = this.immediateSubject.pipe(map((/**
         * @param {?} t
         * @return {?}
         */
        function (t) { return ((/** @type {?} */ ({ type: t, immediate: true }))); })));
        /** @type {?} */
        var thresholdObserver = race(delayedSubject.pipe(debounce((/**
         * @return {?}
         */
        function () { return timer(_this._threshold); }))), immediateSubject).pipe(take(1), tap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.updatePublicState(action.type);
        })), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            if (action.type == SpinnerActionType.Show) {
                return (/** @type {?} */ ({ type: SpinnerActionType.Hide, immediate: false }));
            }
            else {
                return action;
            }
        })));
        /** @type {?} */
        var timeoutObserver = race(thresholdObserver.pipe(switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return (action.immediate ? of(action) : timer(_this._timeout).pipe(map((/**
         * @param {?} _
         * @return {?}
         */
        function (_) { return action; })))); }))), immediateSubject).pipe(take(1));
        timeoutObserver.subscribe((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.updatePublicState(action.type);
        }), (/**
         * @param {?} error
         * @return {?}
         */
        function (error) { return console.error(error); }), (/**
         * @return {?}
         */
        function () { return _this.raceSubject(); }));
    };
    /**
     * @return {?}
     */
    NgxLoadingSpinnerService.prototype.show = /**
     * @return {?}
     */
    function () {
        this.actionRequested = SpinnerActionType.Show;
        this.immediateSubject.next(SpinnerActionType.None);
        this.delayedSubject.next(SpinnerActionType.Show);
    };
    /**
     * @return {?}
     */
    NgxLoadingSpinnerService.prototype.hide = /**
     * @return {?}
     */
    function () {
        this.actionRequested = SpinnerActionType.Hide;
        this.immediateSubject.next(SpinnerActionType.Hide);
    };
    //
    //
    /**
     * @private
     * @return {?}
     */
    NgxLoadingSpinnerService.prototype.patchShow = 
    //
    /**
     * @private
     * @return {?}
     */
    function () {
        if (this.actionRequested == SpinnerActionType.Show) {
            if (this.actionExecuted == SpinnerActionType.Show) {
            }
            else {
                this.immediateSubject.next(SpinnerActionType.None);
                this.delayedSubject.next(SpinnerActionType.Show);
            }
        }
    };
    /**
     * @private
     * @param {?} type
     * @return {?}
     */
    NgxLoadingSpinnerService.prototype.updatePublicState = /**
     * @private
     * @param {?} type
     * @return {?}
     */
    function (type) {
        switch (type) {
            case SpinnerActionType.Show:
                this.actionExecuted = type;
                this.visibleSubject.next(true);
                break;
            case SpinnerActionType.Hide:
                this.actionExecuted = type;
                this.visibleSubject.next(false);
                break;
        }
    };
    NgxLoadingSpinnerService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxLoadingSpinnerService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxLoadingSpinnerService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxLoadingSpinnerService_Factory() { return new NgxLoadingSpinnerService(); }, token: NgxLoadingSpinnerService, providedIn: "root" });
    return NgxLoadingSpinnerService;
}());
if (false) {
    /** @type {?} */
    NgxLoadingSpinnerService.prototype.visibleSubject;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerService.prototype.delayedSubject;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerService.prototype.immediateSubject;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerService.prototype.actionRequested;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerService.prototype.actionExecuted;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerService.prototype._timeout;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerService.prototype._threshold;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-loading-spinner.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxLoadingSpinnerComponent = /** @class */ (function () {
    function NgxLoadingSpinnerComponent(service) {
        this.service = service;
        this.zIndex = 100;
        this.visible = false;
    }
    Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "timeout", {
        set: /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            this.service.timeout = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxLoadingSpinnerComponent.prototype, "threshold", {
        set: /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            this.service.threshold = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgxLoadingSpinnerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.subscribeToService();
    };
    /**
     * @private
     * @return {?}
     */
    NgxLoadingSpinnerComponent.prototype.subscribeToService = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.service.visibleSubject.subscribe((/**
         * @param {?} spinnerVisible
         * @return {?}
         */
        function (spinnerVisible) {
            _this.visible = spinnerVisible;
        }));
    };
    NgxLoadingSpinnerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-loading-spinner',
                    template: "<div class=\"overlay noselect\" [class.on]=\"visible\" [class.off]=\"!visible\" [style.zIndex]=\"zIndex\">\r\n    <div class=\"spinner-container\" *ngIf=\"!template; else showTemplate\">\r\n        <div class=\"spinner-item lds-default\"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>\r\n        <div class=\"spinner-item loading-text\" *ngIf=\"loadingText\">{{ loadingText }}</div>\r\n    </div>\r\n</div>\r\n\r\n<ng-template #showTemplate>\r\n  <div class=\"spinner-container\" [innerHTML]=\"template\"></div>\r\n</ng-template>\r\n",
                    styles: [".noselect{-webkit-touch-callout:none;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.overlay{background-color:rgba(24,24,24,.5);position:fixed;top:0;left:0;width:100%;height:100%;-webkit-transition:opacity .5s;transition:opacity .5s;opacity:0;pointer-events:none}.overlay.on{opacity:1;pointer-events:auto}.spinner-container{color:#fff;font-family:Arial,\"Helvetica Neue\",Helvetica,sans-serif;height:100%;display:-webkit-box;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;flex-direction:column;-webkit-box-pack:center;justify-content:center;-webkit-box-align:center;align-items:center}.loading-text{text-shadow:0 0 .5rem #202020;font-size:1.5em;text-align:center}.lds-default{display:inline-block;position:relative;width:80px;height:80px}.lds-default div{position:absolute;width:6px;height:6px;background:#fff;border-radius:50%;-webkit-animation:1.2s linear infinite lds-default;animation:1.2s linear infinite lds-default}.lds-default div:nth-child(1){-webkit-animation-delay:0s;animation-delay:0s;top:37px;left:66px}.lds-default div:nth-child(2){-webkit-animation-delay:-.1s;animation-delay:-.1s;top:22px;left:62px}.lds-default div:nth-child(3){-webkit-animation-delay:-.2s;animation-delay:-.2s;top:11px;left:52px}.lds-default div:nth-child(4){-webkit-animation-delay:-.3s;animation-delay:-.3s;top:7px;left:37px}.lds-default div:nth-child(5){-webkit-animation-delay:-.4s;animation-delay:-.4s;top:11px;left:22px}.lds-default div:nth-child(6){-webkit-animation-delay:-.5s;animation-delay:-.5s;top:22px;left:11px}.lds-default div:nth-child(7){-webkit-animation-delay:-.6s;animation-delay:-.6s;top:37px;left:7px}.lds-default div:nth-child(8){-webkit-animation-delay:-.7s;animation-delay:-.7s;top:52px;left:11px}.lds-default div:nth-child(9){-webkit-animation-delay:-.8s;animation-delay:-.8s;top:62px;left:22px}.lds-default div:nth-child(10){-webkit-animation-delay:-.9s;animation-delay:-.9s;top:66px;left:37px}.lds-default div:nth-child(11){-webkit-animation-delay:-1s;animation-delay:-1s;top:62px;left:52px}.lds-default div:nth-child(12){-webkit-animation-delay:-1.1s;animation-delay:-1.1s;top:52px;left:62px}@-webkit-keyframes lds-default{0%,100%,20%,80%{-webkit-transform:scale(1);transform:scale(1)}50%{-webkit-transform:scale(1.5);transform:scale(1.5)}}@keyframes lds-default{0%,100%,20%,80%{-webkit-transform:scale(1);transform:scale(1)}50%{-webkit-transform:scale(1.5);transform:scale(1.5)}}"]
                }] }
    ];
    /** @nocollapse */
    NgxLoadingSpinnerComponent.ctorParameters = function () { return [
        { type: NgxLoadingSpinnerService }
    ]; };
    NgxLoadingSpinnerComponent.propDecorators = {
        timeout: [{ type: Input }],
        threshold: [{ type: Input }],
        zIndex: [{ type: Input }],
        loadingText: [{ type: Input }],
        template: [{ type: Input }]
    };
    return NgxLoadingSpinnerComponent;
}());
if (false) {
    /** @type {?} */
    NgxLoadingSpinnerComponent.prototype.zIndex;
    /** @type {?} */
    NgxLoadingSpinnerComponent.prototype.loadingText;
    /** @type {?} */
    NgxLoadingSpinnerComponent.prototype.template;
    /** @type {?} */
    NgxLoadingSpinnerComponent.prototype.visible;
    /**
     * @type {?}
     * @private
     */
    NgxLoadingSpinnerComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-loading-spinner.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxLoadingSpinnerModule = /** @class */ (function () {
    function NgxLoadingSpinnerModule() {
    }
    /**
     * @return {?}
     */
    NgxLoadingSpinnerModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NgxLoadingSpinnerModule,
            providers: [NgxLoadingSpinnerService]
        };
    };
    NgxLoadingSpinnerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxLoadingSpinnerComponent],
                    imports: [
                        BrowserModule
                    ],
                    exports: [NgxLoadingSpinnerComponent]
                },] }
    ];
    return NgxLoadingSpinnerModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: k-adam-ngx-loading-spinner.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxLoadingSpinnerComponent, NgxLoadingSpinnerModule, NgxLoadingSpinnerService };
//# sourceMappingURL=k-adam-ngx-loading-spinner.js.map
